
-- return the window size
getWindowSize = getWindowSize or function()
	return 955, 300
end

-- create and lay out all the controls
createUI = createUI or function()

	createUICommon()

	-- constants
	local kKnobSpace = 45
	local kButtonW = 128
	local kButtonH = 27
	local kInfoW = 800
	local kInfoH = 220
	local kPropertyTextFieldH = 20

	-- make groups and knobs
	--

	theKnobRenderer = smallKnobRenderer

	miscGroup = group( "OSC" )
	smallKnobAndTextField( miscGroup, "OSC Port Offset",	"Port",		0, 0 )
	labelledDropDown( miscGroup, "Send OSC", "Send", kKnobSpace, 0 )

	-- positions!

	local xbase = windowEdgePad
	local ybase = windowEdgePad
	local x = xbase
	local y = ybase

	-- add directly positioned objects
	--

	x = xbase
	y = ybase + pad
	add( learnerInfoDisplay( x, y, kInfoW, kInfoH ) )

	local kCopyButtonW = 70
	local kCopyButtonH = 18
	local kCopyButtonSpace = 19
	add( propertyTriggerButton( 64133, "Copy", "Copy long OSC path to Clipboard",		x+500, y+3+2*kCopyButtonSpace, kCopyButtonW, kCopyButtonH ) )
	add( propertyTriggerButton( 64134, "Copy", "Copy compact OSC path to Clipboard",	x+500, y+3+kCopyButtonSpace, kCopyButtonW, kCopyButtonH ) )
	add( propertyTriggerButton( 64135, "Copy", "Copy short OSC path to Clipboard",		x+500, y+3, kCopyButtonW, kCopyButtonH ) )

	x = x + kInfoW + pad

	add( propertyButton( 64130, "Learn Active", "Activate MIDI learn", "toggle", x, y, kButtonW, kButtonH ) )
	y = y + kButtonH + pad

	add( propertyTriggerButton( 64131, "Remove", "Remove MIDI mapping", x, y, kButtonW, kButtonH ) )
	y = y + kButtonH + pad

	add( propertyTriggerButton( 64132, "Remove All", "Remove all MIDI mappings", x, y, kButtonW, kButtonH ) )
	y = y + kButtonH + pad

	miscGroup:setPosition( x, y, true )
	
	local kPrefsW = 53

	local kLabelW = 55
	local ww, wh = getWindowSize()
	local kPortW = ww - ( xbase + kLabelW + pad + pad + kPrefsW + windowEdgePad )
	x = xbase
	y = ybase + pad + kInfoH + pad

	add( propertyTextField( 64110, "Enter target address and port (e.g. 127.0.0.1:7000)", x+kLabelW+pad, y, kPortW, kPropertyTextFieldH ) )
	local lab = label( "Target:", x, y+0.5*(kPropertyTextFieldH-kTextFieldH), "center", kLabelW, kTextFieldH )
	setLabelColour( lab )
	add( lab )
	if isMac then
		add( bonjourButton( "Browse", "Browse for OSC target", 64110, x+kLabelW+pad+kPortW+pad, y, kPrefsW, kPropertyTextFieldH ) )
	end

end		-- of createUI()
